<h1 id="select">Select</h1>
<p>Select is a dropdown list of options that mimics a native HTML <code>&lt;select&gt;</code> that has attribute <code>size</code> with a value of 1 or without it, while allowing more styling flexibility.</p>
<p>Select conforms to the <a href="https://www.w3.org/WAI/ARIA/apg/example-index/combobox/combobox-select-only.html">W3C WAI-ARIA authoring practices</a>, with the exception of a few minor interactions that allow it to more closely mimic a native HTML <code>&lt;select&gt;</code> element.</p>
<h2 id="set-up">Set up</h2>
<p>First import the styles into your main SASS file, replacing <code>&lt;path-to-node_modules&gt;</code> with the path to the <em>node_modules</em> directory relative to the file:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/select/select';
</code></pre>
<p>Alternatively <em>ace.scss</em> includes all ACE component SASS files, so if using multiple ACE components it can be imported instead:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/ace';
</code></pre>
<p>A CSS file is also provided for convenience and is located at <code>&lt;path-to-node_modules&gt;/@potato/ace/components/select/ace-select.css</code>.</p>
<p>Then import the class into your JavaScript entry point:</p>
<pre><code class="language-js">import '&lt;path-to-node_modules&gt;/@potato/ace/components/select/select';
</code></pre>
<p>For convenience the ES6 class is exported as <code>Select</code> and the attribute names used by the class are exported as properties of <code>ATTRS</code>.</p>
<p>After the event <code>DOMContentLoaded</code> is fired on <code>document</code> an instance of Select is instantiated within each <code>&lt;ace-select&gt;</code> element and an ID <code>ace-select-&lt;n&gt;</code> is added for any instance without one, where <code>&lt;n&gt;</code> is a unique integer. Once instantiation is complete a custom event <code>ace-select-ready</code> is dispatched to <code>window</code>. See the <strong>Custom events</strong> section below for more details.</p>
<p>Select must have a descendant button to show the hidden list of options, so if one is not present Select will create a <code>&lt;button&gt;</code> to use, prepend it to itself and update its text to match that of the first option in the list. Select must also have a descendant list and will use the first descendant <code>&lt;ul&gt;</code> for this. This list can be empty upon instantiation and options can be dynamically added to, or removed from, it later as long as custom event <code>ace-select-update-options</code> is dispatched to the Select instance afterwards.</p>
<p>If using a Select in a HTML <code>&lt;form&gt;</code> the attribute <code>ace-select-for-form</code> can be added to it which causes it to create a hidden <code>&lt;input&gt;</code> with attribute <code>ace-select-input</code>. The value of the selected option is stored as the value of the <code>&lt;input&gt;</code> in the form of a URI encoded string. Similarly, the selected option ID is stored as the value of the <code>&lt;input&gt;</code> attribute <code>data-ace-listbox-selected-option-id</code>.</p>
<p>If using a Select in a HTML <code>&lt;form&gt;</code> the attribute <code>ace-select-for-form</code> can be added to it which causes it to create a hidden <code>&lt;input&gt;</code> with attribute <code>ace-select-input</code>. The value of the selected option is stored as the value of the <code>&lt;input&gt;</code> in the form of a URI encoded string. Similarly, the selected option ID is stored as the value of the <code>&lt;input&gt;</code> attribute <code>data-ace-listbox-selected-option-id</code>.</p>
<h2 id="usage">Usage</h2>
<p>The list of options is displayed when users click on the trigger or press <kbd>↑</kbd>, <kbd>↓</kbd>, <kbd>Enter</kbd> or <kbd>Space</kbd> while the trigger is focused, with <kbd>↑</kbd> selecting the last option in the list and the other three keys selecting the first. The list is aware of it's position within the window and ensures that it is fully visible in the viewport. It will hence appear below the trigger and aligned to it's left edge if there is enough space, otherwise it will appear above and/or aligned to the right edge, as necessary.</p>
<p>Clicking on an option or navigating to it using <kbd>↑</kbd> or <kbd>↓</kbd> and pressing <kbd>Enter</kbd> or <kbd>Space</kbd> will select the option, hide the list and update the trigger text to match that of the selected option, and then dispatch the <code>ace-select-option-chosen</code> custom event.</p>
<p>Type-ahead can also be used to select an option by typing one or more characters that the option's text starts with. Repeatedly typing the same character with a short delay in-between will cycle through all matching options. Type-ahead can be used on a focused trigger, which will select the option and update the trigger text, or in a list where it will only select the option but not update the trigger text until <kbd>Enter</kbd> or <kbd>Space</kbd> are pressed to confirm. Pressing <kdb>Esc</kbd> or clicking outside the Select component hides a shown list without confirming a change in the selected option.</p>
<h2 id="styles">Styles</h2>
<p>The following SASS is applied to Select. The SASS variables use <code>!default</code> so can also be easily overridden by users. SASS variables used that are not defined here are defined in <em>&lt;path-to-node_modules&gt;/@potato/ace/common/constants.scss</em>.</p>
<pre><code class="language-scss">@import '../../common/constants';


// VARIABLES
$ace-select-list-bg-color: #fff !default;
$ace-select-list-height: auto !default;
$ace-select-option-text-color: #000 !default;
$ace-select-selected-option-bg-color: $ace-color-selected !default;
$ace-select-selected-option-text-color: #fff !default;


// STYLES
ace-select {
	position: relative;
}

[ace-select-list] {
	background: $ace-select-list-bg-color;
	color: $ace-select-option-text-color;
	height: $ace-select-list-height;
	left: 0;
	list-style: none;
	overflow-y: auto;
	position: absolute;
	user-select: none;
	white-space: nowrap;
	z-index: $ace-select-list-z-index;

	&amp;:not([ace-select-list-visible]) {
		display: none;
	}

	[aria-selected=&quot;true&quot;] {
		background: $ace-select-selected-option-bg-color;
		color: $ace-select-selected-option-text-color;
	}

	&amp;[ace-u-float-above] {
		bottom: 100%;
		top: initial;
	}

	&amp;[ace-u-float-left] {
		left: initial;
		right: 0;
	}

	&amp;[ace-u-float-right] {
		left: 0;
		right: initial;
	}
}
</code></pre>
<h2 id="custom-events">Custom events</h2>
<p>Select uses the following custom events, the names of which are available in its exported <code>EVENTS</code> object, similar to <code>ATTRS</code>, so they may be imported into other modules.</p>
<h3 id="dispatched-events">Dispatched events</h3>
<p>The following events are dispatched to <code>window</code> by Select.</p>
<h4 id="ready">Ready</h4>
<p><code>ace-select-ready</code></p>
<p>This event is dispatched when Select finishes initialising just after page load, and after dynamically added options are initialised in response to the <code>ace-select-update-options</code> custom event being dispatched. The event name is available as <code>EVENTS.OUT.READY</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Select [string]
}
</code></pre>
<h4 id="option-chosen">Option chosen</h4>
<p><code>ace-select-option-chosen</code></p>
<p>This event is dispatched when an option is chosen by the user. The event name is available as <code>EVENTS.OUT.OPTION_CHOSEN</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Select [string],
	'chosenOption': {
		'id': // ID of chosen option [string],
		'index': // Index of chosen option [number]
	},
}
</code></pre>
<h3 id="listened-for-event">Listened for event</h3>
<p>Select listens for the following event that should be dispatched to <code>window</code>.</p>
<h4 id="update-options">Update options</h4>
<p><code>ace-select-update-options</code></p>
<p>This event should be dispatched when options are added to or removed from the list and causes Select to initialise them and then dispatch the <code>ace-select-ready</code> event. The event name is available as <code>EVENTS.IN.UPDATE_OPTIONS</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Select [string]
}
</code></pre>
<h2 id="examples">Examples</h2>
<p>Each example contains a live demo and the HTML code that produced it. The code shown may differ slightly to that rendered for the demo as some components may alter their HTML when they initialise.</p>
<h3 id="simple-select">Simple Select</h3>
<p>The default Select.</p>
<div class="example-block"><label id="ace-select-1-label">Choose an Avenger:</label>
<ace-select>
	<ul aria-labelledby="ace-select-1-label">
		<li>Select an option</li>
		<li>Iron Man</li>
		<li>Nick Fury</li>
		<li>Hulk</li>
		<li>Black Widow</li>
		<li>Thor</li>
		<li>Captain America</li>
		<li>Scarlet Witch</li>
		<li>Ant-Man</li>
		<li>Spider-man</li>
		<li>Black Panther</li>
		<li>Doctor Strange</li>
		<li>Captain Marvel</li>
	</ul>
</ace-select>
</div>
<pre><code class="language-html">&lt;label id=&quot;ace-select-1-label&quot;&gt;Choose an Avenger:&lt;/label&gt;
&lt;ace-select&gt;
	&lt;ul aria-labelledby=&quot;ace-select-1-label&quot;&gt;
		&lt;li&gt;Select an option&lt;/li&gt;
		&lt;li&gt;Iron Man&lt;/li&gt;
		&lt;li&gt;Nick Fury&lt;/li&gt;
		&lt;li&gt;Hulk&lt;/li&gt;
		&lt;li&gt;Black Widow&lt;/li&gt;
		&lt;li&gt;Thor&lt;/li&gt;
		&lt;li&gt;Captain America&lt;/li&gt;
		&lt;li&gt;Scarlet Witch&lt;/li&gt;
		&lt;li&gt;Ant-Man&lt;/li&gt;
		&lt;li&gt;Spider-man&lt;/li&gt;
		&lt;li&gt;Black Panther&lt;/li&gt;
		&lt;li&gt;Doctor Strange&lt;/li&gt;
		&lt;li&gt;Captain Marvel&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-select&gt;
</code></pre>
<h3 id="select-for-forms">Select for forms</h3>
<p>A Select to be used with HTML forms, with a hidden <code>&lt;input&gt;</code> with the selected option data.</p>
<div class="example-block"><label id="ace-select-1-label">Choose an Avenger:</label>
<ace-select ace-select-for-form id="ace-select-for-form">
	<ul aria-labelledby="ace-select-1-label">
		<li>Select an option</li>
		<li>Iron Man</li>
		<li>Nick Fury</li>
		<li>Hulk</li>
		<li>Black Widow</li>
		<li>Thor</li>
		<li>Captain America</li>
		<li>Scarlet Witch</li>
		<li>Ant-Man</li>
		<li>Spider-man</li>
		<li>Black Panther</li>
		<li>Doctor Strange</li>
		<li>Captain Marvel</li>
	</ul>
</ace-select>
</div>
<pre><code class="language-html">&lt;label id=&quot;ace-select-1-label&quot;&gt;Choose an Avenger:&lt;/label&gt;
&lt;ace-select ace-select-for-form id=&quot;ace-select-for-form&quot;&gt;
	&lt;ul aria-labelledby=&quot;ace-select-1-label&quot;&gt;
		&lt;li&gt;Select an option&lt;/li&gt;
		&lt;li&gt;Iron Man&lt;/li&gt;
		&lt;li&gt;Nick Fury&lt;/li&gt;
		&lt;li&gt;Hulk&lt;/li&gt;
		&lt;li&gt;Black Widow&lt;/li&gt;
		&lt;li&gt;Thor&lt;/li&gt;
		&lt;li&gt;Captain America&lt;/li&gt;
		&lt;li&gt;Scarlet Witch&lt;/li&gt;
		&lt;li&gt;Ant-Man&lt;/li&gt;
		&lt;li&gt;Spider-man&lt;/li&gt;
		&lt;li&gt;Black Panther&lt;/li&gt;
		&lt;li&gt;Doctor Strange&lt;/li&gt;
		&lt;li&gt;Captain Marvel&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-select&gt;
</code></pre>
<h3 id="select-with-dynamic-options">Select with dynamic options</h3>
<p>In this example the Select instantiates with an empty <code>&lt;ul&gt;</code> that can be populated with options using <strong>Add option</strong>. The last option can be removed using the <strong>Remove option</strong>. Both these buttons dispatch the <code>ace-select-update-options</code> event that updates the list options, and the trigger text. The extra JavaScript code required by this example is also included below.</p>
<div class="example-block"><button id="add-option">
	Add option
</button>
<button id="remove-option">
	Remove option
</button>
<hr>
<label id="custom-events-select-label">Choose an Avenger:</label>
<ace-select id="ace-custom-events-select">
	<button><span ace-select-trigger-text>No options available</span></button>
	<ul aria-labelledby="custom-events-select-label"></ul>
</ace-select>
</div>
<pre><code class="language-html">&lt;button id=&quot;add-option&quot;&gt;
	Add option
&lt;/button&gt;
&lt;button id=&quot;remove-option&quot;&gt;
	Remove option
&lt;/button&gt;
&lt;hr&gt;
&lt;label id=&quot;custom-events-select-label&quot;&gt;Choose an Avenger:&lt;/label&gt;
&lt;ace-select id=&quot;ace-custom-events-select&quot;&gt;
	&lt;button&gt;&lt;span ace-select-trigger-text&gt;No options available&lt;/span&gt;&lt;/button&gt;
	&lt;ul aria-labelledby=&quot;custom-events-select-label&quot;&gt;&lt;/ul&gt;
&lt;/ace-select&gt;
</code></pre>
<pre><code class="language-js">import { EVENTS } from '/ace/components/select/select.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const SELECT_ID = 'ace-custom-events-select';
	const selectListEl = document.querySelector(`#${SELECT_ID} ul`);

	const updateOptions = () =&gt; window.dispatchEvent(new CustomEvent(
		EVENTS.IN.UPDATE_OPTIONS,
		{'detail': {'id': SELECT_ID}},
	));

	document.getElementById('add-option').addEventListener('click', () =&gt; {
		const optionEl = document.createElement('li');
		optionEl.textContent = 'Option';
		selectListEl.appendChild(optionEl);
		updateOptions();
	});

	document.getElementById('remove-option').addEventListener('click', () =&gt; {
		const lastOptionEl = selectListEl.querySelector('li:last-child');
		if (lastOptionEl) {
			selectListEl.removeChild(lastOptionEl);
			updateOptions();
		}
	});
});
</code></pre>
<h3 id="styled-select">Styled Select</h3>
<p>An example of how Select can be styled, with the applied CSS shown below.</p>
<div class="example-block"><label id="styled-select-label" class="styled-select-label">Choose an Avenger:</label>
<ace-select class="styled-select">
	<button ace-select-trigger class="styled-select__trigger">
	</button>
	<ul aria-labelledby="styled-select-label" class="styled-select__list">
		<li class="styled-select__option">
			Select an option
		</li>
		<li class="styled-select__option">
			<img alt="Potato logo" class="styled-select__img" src="/img/logo.svg" />
			Iron Man
		</li>
		<li class="styled-select__option">
			<img alt="Potato logo" class="styled-select__img" src="/img/logo.svg" />
			Nick Fury
		</li>
		<li class="styled-select__option">
			<img alt="Potato logo" class="styled-select__img" src="/img/logo.svg" />
			Hulk
		</li>
		<li class="styled-select__option">
			<img alt="Potato logo" class="styled-select__img" src="/img/logo.svg" />
			Thor
		</li>
		<li class="styled-select__option">
			<img alt="Potato logo" class="styled-select__img" src="/img/logo.svg" />
			Captain America
		</li>
		<li class="styled-select__option">
			<img alt="Potato logo" class="styled-select__img" src="/img/logo.svg">
			Black Widow
		</li>
		<li class="styled-select__option">
			<img alt="Potato logo" class="styled-select__img" src="/img/logo.svg" />
			Scarlet Witch
		</li>
	</ul>
</ace-select>
</div>
<pre><code class="language-html">&lt;label id=&quot;styled-select-label&quot; class=&quot;styled-select-label&quot;&gt;Choose an Avenger:&lt;/label&gt;
&lt;ace-select class=&quot;styled-select&quot;&gt;
	&lt;button ace-select-trigger class=&quot;styled-select__trigger&quot;&gt;
	&lt;/button&gt;
	&lt;ul aria-labelledby=&quot;styled-select-label&quot; class=&quot;styled-select__list&quot;&gt;
		&lt;li class=&quot;styled-select__option&quot;&gt;
			Select an option
		&lt;/li&gt;
		&lt;li class=&quot;styled-select__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-select__img&quot; src=&quot;/img/logo.svg&quot; /&gt;
			Iron Man
		&lt;/li&gt;
		&lt;li class=&quot;styled-select__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-select__img&quot; src=&quot;/img/logo.svg&quot; /&gt;
			Nick Fury
		&lt;/li&gt;
		&lt;li class=&quot;styled-select__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-select__img&quot; src=&quot;/img/logo.svg&quot; /&gt;
			Hulk
		&lt;/li&gt;
		&lt;li class=&quot;styled-select__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-select__img&quot; src=&quot;/img/logo.svg&quot; /&gt;
			Thor
		&lt;/li&gt;
		&lt;li class=&quot;styled-select__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-select__img&quot; src=&quot;/img/logo.svg&quot; /&gt;
			Captain America
		&lt;/li&gt;
		&lt;li class=&quot;styled-select__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-select__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Black Widow
		&lt;/li&gt;
		&lt;li class=&quot;styled-select__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-select__img&quot; src=&quot;/img/logo.svg&quot; /&gt;
			Scarlet Witch
		&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-select&gt;
</code></pre>
<pre><code class="language-scss">.styled-select {
	display: block;
	margin-top: 10px;

	&amp;-label,
	&amp;__trigger,
	&amp;__option {
		font-family: 'Roboto', sans-serif;
		font-size: 14px;
	}

	&amp;__trigger,
	&amp;__list {
		border: 1px solid #837b8b;
		border-radius: 4px;
		width: 300px;

		&amp;:focus {
			outline-color: #41354d;
		}
	}

	&amp;__trigger,
	&amp;__option {
		padding: 10px 16px;
	}

	&amp;__trigger {
		background: transparent;
		display: flex;
		justify-content: space-between;

		&amp;::after {
			color: #837b8b;
			content: '\25BC';
		}

		&amp;:focus::after {
			color: #41354d;
		}
	}

	&amp;__list {
		height: 225px;
	}

	&amp;__option {
		align-items: center;
		display: flex;

		&amp;[aria-selected=&quot;true&quot;] {
			background: #41354d;
		}
	}

	&amp;__img {
		height: 2em;
		margin-right: 10px;
	}
}
</code></pre>
